unit ChannelList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpCheckBox, ComCtrls, SpButton, SpComboBox, SpEdit,
  ExtCtrls,Config, SpMemo;

type
  TChannelListForm = class(TForm)
    Label1: TLabel;
    SpComboBox1: TSpComboBox;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    CheckBox1: TCheckBox;
    SpButton3: TSpButton;
    SpMemo1: TSpMemo;
    Bevel3: TBevel;
    SpEdit1: TSpEdit;
    UpDown3: TUpDown;
    Label2: TLabel;
    Label3: TLabel;
    SpEdit2: TSpEdit;
    UpDown1: TUpDown;
    procedure SpButton1Click(Sender: TObject);
    procedure SpButton2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ConfigureComponents;
    procedure SpButton3Click(Sender: TObject);
  private
  public
  end;

var
  ChannelListForm: TChannelListForm;

implementation
{$R *.dfm}
Uses unit3, Main;

procedure TChannelListForm.SpButton1Click(Sender: TObject);
begin

 if Form3 = nil then Form3 := TForm3.Create(Self );

 if not(Form3.Focused) then
  begin
   Form3.Show;
   Form3.Refresh;
  end;
 Form1.IRC.Raw('LIST');  
 Close;
end;

procedure TChannelListForm.SpButton2Click(Sender: TObject);
var
 ListItem : TListItem;
 Strings : TStrings;
 i : integer;
begin
   if form3=nil then Form3 := TForm3.Create(Self );

   Strings  := TStringList.Create;
   Strings.LoadFromFile('1.lst');
   Form3.Caption := CStr('F3Caption')+Strings[0];
   i:=1;
   repeat
    ListItem := Form3.ListView2.Items.Add;
    ListItem.Caption :=  Strings[i];
    ListItem.SubItems.Add(Strings[i+1]);
    ListItem.SubItems.Add(Strings[i+2]);
    inc(i,3);
   until i > Strings.Count-1;

   Form3.AddFiltredChannel;

   Close;
end;

procedure TChannelListForm.FormActivate(Sender: TObject);
begin
 ConfigureComponents;
 SpButton1.Enabled := Form1.IRC.Connected;
end;

procedure TChannelListForm.ConfigureComponents;
begin
 Caption := CStr('CLCaption');

 SpButton1.Caption := CStr('CLButton1');
 SpButton2.Caption := CStr('CLButton2');
 SpButton3.Caption := CStr('CLButton3');

 SpMemo1.Text := CStr('CLMemo1');

 Label1.Caption := CStr('CLLabel1');





 CheckBox1.Caption :=CStr('CLCheckBox1');






 UpDown3.Position := StrToInt(CStr('CLUpDown3'));



end;


procedure TChannelListForm.SpButton3Click(Sender: TObject);
begin
 Close;
end;

end.
