unit EditConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, SpRichEdit,Config;

type
  TEditConfigForm = class(TForm)
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    SpRichEdit1: TSpRichEdit;
    SpRichEdit2: TSpRichEdit;
    SpRichEdit3: TSpRichEdit;
    SpRichEdit4: TSpRichEdit;
    SpRichEdit5: TSpRichEdit;
    SpRichEdit6: TSpRichEdit;
    SpRichEdit7: TSpRichEdit;
    procedure FormActivate(Sender: TObject);
    procedure SpRichEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
  end;

var
  EditConfigForm: TEditConfigForm;
  ShowPage : word;
implementation
{$R *.dfm}
uses Main;

procedure TEditConfigForm.FormActivate(Sender: TObject);
begin
  inherited;
  Form1.Speech1.Speak('  ');
  PageControl1.ActivePageIndex := ShowPage;

  SpRichEdit1.Lines.LoadFromFile(StartDir + '/'+ConfigDir+'/' + CaptionConfig);
  SpRichEdit2.Lines.LoadFromFile(StartDir + '/'+ConfigDir+'/' + UserConfigFileName);
  SpRichEdit3.Lines.LoadFromFile(StartDir + '/'+ConfigDir+'/' + ServersConfigFileName);
  SpRichEdit4.Lines.LoadFromFile(StartDir + '/'+ConfigDir+'/' + FaworitsConfigFileName);
  SpRichEdit5.Lines.LoadFromFile(StartDir + '/'+ConfigDir+'/' + SpeechConfigFileName);
  SpRichEdit6.Lines.LoadFromFile(StartDir + '/'+ 'multirules.ini');
  SpRichEdit7.Lines.LoadFromFile(StartDir + '/'+ 'singlerules.ini');

end;

procedure TEditConfigForm.SpRichEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_ESCAPE then Close;
 if ssCtrl in Shift then
  begin
   case chr(Key) of
    'S','s' : SpRichEdit1.Lines.SaveToFile(StartDir + '/' + CaptionConfig);
    'R','r' : SpRichEdit1.Lines.LoadFromFile(StartDir + '/' + CaptionConfig);
   end;
  end;
end;

end.
