unit main;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdIPMCastBase, IdIPMCastClient,
  StdCtrls, IdTCPServer, IdIrcServer, IdTCPConnection, IdTCPClient, IdIRC,
  Menus, ComCtrls, ExtCtrls, jpeg, Buttons, FileCtrl, ImgList, ToolWin,
  ActnList, XPStyleActnCtrls, ActnMan, ActnCtrls, ActnMenus, StdActns,
  IdIOHandler, IdIOHandlerSocket, IdIntercept, Service, Config, ServerOptions,
  speech, SpTreeView, SpComboBox, SpCheckBox, ChannelList,EditConfig,mmsystem,
  ShellAPI, SpButton,SpShowMessage, AppEvnts, XPMan;

const
 LogFileName = 'log\trafic.log';

 RunOnce  : boolean = true;
 GlobalCanSpeak : boolean = true;

 GlobalCodePageName : string = Win1251Name;

 cmd_WELCOME = 'WELCOME';
 cmd_LUSER   = 'LUSER';
 cmd_MOTD    = 'MOTD';
// statusfile : string = '3.bmp';

  LangIDUkrainian = $0022 ;
  LangIDRussian   = $0019 ;
  LangIDEnglishUS = $0009 ;

  LangNameUkrainian  = '';
  LangNameRussian    = '';
  LangNameEnglishUS  = '';
  LangNameUnUse      = ' ';

type
  SpeechConfigurationRecord = record

   UseInterfaceEngine,
   UseChannelEngine : boolean;

   ActiveControl : byte; {0-interface, 1-Channel}

   InterfaceEngineName : string;
   IESpeed  : word;
   IEPitch  : word;
   IEVolume : word;
   IEUseMultiFilter,
   IEUseSingleFilter : boolean;

   ChannelEngineName : string;
   CESpeed  : word;
   CEPitch  : word;
   CEVolume : word;
   CEUseMultiFilter,
   CEUseSingleFilter : boolean;
  end;

  TForm1 = class(TForm)
    IRC: TIdIRC;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Label1: TLabel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ImageList1: TImageList;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList2: TImageList;
    ImageList3: TImageList;
    ActionManager1: TActionManager;
    A_Server: TAction;
    A_Connect: TAction;
    A_Exit: TAction;
    A_Panels: TAction;
    Channels: TAction;
    A_SetSpeakPanel: TAction;
    A_ChannelList: TAction;
    A_Keyboard: TAction;
    sep1: TAction;
    MainMenu1: TMainMenu;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Button1: TButton;
    A_Help: TAction;
    A_About: TAction;
    A_Join: TAction;
    A_Part: TAction;
    A_Query: TAction;
    A_Notice: TAction;
    A_Whois: TAction;
    A_Ban: TAction;
    A_Kick: TAction;
    A_Nick: TAction;
    A_Windows: TAction;
    WindowClose1: TWindowClose;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    Panel6: TPanel;
    SpeedButton2: TSpeedButton;
    A_StatusPanel: TAction;
    A_ToolsPanel: TAction;
    A_SelectStatusPanel: TAction;
    IdConnectionIntercept1: TIdConnectionIntercept;
    IdIOHandlerSocket1: TIdIOHandlerSocket;
    A_CodePage: TAction;
    A_CP1251: TAction;
    A_KOI8: TAction;
    A_OEM: TAction;
    Timer1: TTimer;
    ToolButton5: TToolButton;
    Speech1: TSpeech;
    SpComboBox1: TSpComboBox;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    A_GetFocuse: TAction;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    About1: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    CodePage1: TMenuItem;
    Koi81: TMenuItem;
    OEM1: TMenuItem;
    Win12511: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    N29: TMenuItem;
    Panel7: TPanel;
    ToolBar2: TToolBar;
    ToolButton10: TToolButton;
    Speech2: TSpeech;
    oolspanel1: TMenuItem;
    A_Tools: TAction;
    A_ConfigEditor: TAction;
    A_Faworits: TAction;
    SpComboBox2: TSpComboBox;
    SpButton1: TSpButton;
    SpButton3: TSpButton;
    SpCheckBox1: TSpCheckBox;
    SpButton2: TSpButton;
    SpCheckBox3: TSpCheckBox;
    SpButton4: TSpButton;
    Bevel1: TBevel;
    SpButton5: TSpButton;
    SpCheckBox5: TSpCheckBox;
    Label6: TLabel;
    Channelslist1: TMenuItem;
    A_Message: TAction;
    Message1: TMenuItem;
    Query1: TMenuItem;
    N7: TMenuItem;
    Whois1: TMenuItem;
    A_Who: TAction;
    who1: TMenuItem;
    ImageList4: TImageList;
    XPManifest1: TXPManifest;
    ApplicationEvents1: TApplicationEvents;
    procedure IRCReceive(Sender: TObject; ACommand: String);
    procedure IRCSend(Sender: TObject; ACommand: String);
    procedure Button3Click(Sender: TObject);
    procedure A_Panels4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure IRCList(Sender: TObject; AChans: TStringList; APosition: Integer; ALast: Boolean);
    procedure A_ChannelListExecute(Sender: TObject);
    procedure DisConnect1Click(Sender: TObject);
    procedure IRCError(Sender: TObject; AUser: TIdIRCUser; ANumeric, AError: String);
    procedure Jointochanel1Click(Sender: TObject);
    procedure IRCJoined(Sender: TObject; AChannel: TIdIRCChannel);
    procedure A_Connect1Click(Sender: TObject);
    procedure A_SetSpeakPanelClickClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure IRCMessage(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; Content: String);
    procedure A_KeyboardClick(Sender: TObject);
    procedure A_Exit1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure IRCJoin(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel);
    procedure IRCPart(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel);
    procedure Create1Click(Sender: TObject);
    procedure IRCDCCChat(Sender: TObject; ANick, AIp, APort: String);
    procedure IRCDCCAccept(Sender: TObject; ANick, APort, AFileName,APosition: String);
    procedure IRCDCCResume(Sender: TObject; ANick, APort, AFileName,APosition: String);
    procedure IRCDCCSend(Sender: TObject; ANick, AIp, APort, AFileName,AFileSize: String);
    procedure IRCChannelMode(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; AChanName, AModes: String);
    procedure IRCChannelModeChanged(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel);
    procedure IRCChannelUpdate(Sender: TObject; AUpdateType: TIdIRCChannelUpdateType; AUser: TIdIRCUser;    AInfo: Integer);
    procedure IRCBan(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel; AHostmask: String);
    procedure IRCInvite(Sender: TObject; AUser: TIdIRCUser;AChannel: String);
    procedure IRCInviting(Sender: TObject; ANick, AChannel: String);
    procedure IRCKick(Sender: TObject; AUser, AVictim: TIdIRCUser; AChannel: TIdIRCChannel);
    procedure IRCKicked(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel);
    procedure IRCKill(Sender: TObject; User: TIdIRCUser; AVictim,AReason: String);
    procedure IRCLinks(Sender: TObject; AMask, AServer, AHopCount, AServerInfo: String);
    procedure IRCNames(Sender: TObject; AUsers: TIdIRCUsers;AChannel: TIdIRCChannel);
    procedure IRCNickChange(Sender: TObject; AUser: TIdIRCUser;ANewNick: String);
    procedure IRCNickChanged(Sender: TObject; AOldNick: String);
    procedure IRCNicksInUse(Sender: TObject; var ANick: String);
    procedure IRCNotice(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; Content: String);
    procedure IRCNoTopic(Sender: TObject; AChannel: TIdIRCChannel;AContent: String);
    procedure IRCNowAway(Sender: TObject; AContent: String);
    procedure IRCOp(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; ATarget: TIdIRCUser);
    procedure IRCParted(Sender: TObject; AChannel: TIdIRCChannel);
    procedure IRCPingPong(Sender: TObject);
    procedure IRCQuit(Sender: TObject; AUser: TIdIRCUser);
    procedure IRCRaw(Sender: TObject; AUser: TIdIRCUser; ACommand,AContent: String; var Suppress: Boolean);
    procedure IRCSocketError(Sender: TObject; ASocket, AMsg: String);
    procedure IRCStateChange(Sender: TObject);
    procedure IRCSystem(Sender: TObject; AUser: TIdIRCUser;ACmdCode: Integer; ACommand, AContent: String);
    procedure IRCTopic(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; const AChanName, ATopic: String);
    procedure IRCUnAway(Sender: TObject; AContent: String);
    procedure IRCUnban(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; AHostmask: String);
    procedure IRCUnknownCommand(Sender: TObject; AUser: TIdIRCUser;ACommand, AContent: String);
    procedure IRCUserMode(Sender: TObject; AModes: String);
    procedure IRCUserModeChanged(Sender: TObject);
    procedure IRCVoice(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel; ATarget: TIdIRCUser);
    procedure IRCWallops(Sender: TObject; AUser: TIdIRCUser;AContent: String);
    procedure IRCWork(Sender: TObject; AWorkMode: TWorkMode;const AWorkCount: Integer);
    procedure IRCWorkBegin(Sender: TObject; AWorkMode: TWorkMode; const AWorkCountMax: Integer);
    procedure IRCWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure A_CommandClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure A_AboutExecute(Sender: TObject);
    procedure A_HelpExecute(Sender: TObject);
    procedure SetChannelEvent( ChannelName, Event : string);
    procedure UpdateUserList( AChannel : TIdIRCChannel);
    procedure A_PartExecute(Sender: TObject);
    procedure A_QueryExecute(Sender: TObject);
    procedure A_NoticeExecute(Sender: TObject);
    procedure A_WhoisExecute(Sender: TObject);
    procedure A_BanExecute(Sender: TObject);
    procedure A_KickExecute(Sender: TObject);
    procedure A_NickExecute(Sender: TObject);
    procedure A_WindowsExecute(Sender: TObject);
    procedure SetAllChannelEvent( Event : string);
    procedure A_ToolsPanelExecute(Sender: TObject);
    procedure SpTreeView1CustomDrawItem(Sender: TCustomTreeView;Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure IdConnectionIntercept1Receive(ASender: TIdConnectionIntercept; AStream: TStream);
    procedure IdConnectionIntercept1Send(ASender: TIdConnectionIntercept;AStream: TStream);
    procedure A_CP1251Execute(Sender: TObject);
    procedure A_KOI8Execute(Sender: TObject);
    procedure A_OEMExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure A_CodePageExecute(Sender: TObject);
    procedure IdConnectionIntercept1Connect(ASender: TIdConnectionIntercept);
    procedure IdConnectionIntercept1Disconnect(ASender: TIdConnectionIntercept);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ConfigureComponentCaptionText;
    procedure A_GetFocuseExecute(Sender: TObject);
    procedure SayMainMenu( MenuPos , SubMenuPos : integer );
    procedure MenuMessage(var Msg: TMessage);message WM_MENUSELECT;
    function _Filter(Text : string ):string;
    procedure SpeakLang;
    procedure FormHide(Sender: TObject);
    procedure ToolBar2CustomDrawButton(Sender: TToolBar;Button: TToolButton; State: TCustomDrawState;var DefaultDraw: Boolean);
    procedure ChannelWathClick( Sender : TObject );
    procedure A_ServerExecute(Sender: TObject);
    procedure IRCStatus(ASender: TObject; const AStatus: TIdStatus;const AStatusText: String);
    procedure A_ToolsSetup(Sender: TObject);
    procedure A_ConfigEditorExecute(Sender: TObject);
    procedure A_FaworitsExecute(Sender: TObject);
    procedure ConfigureSpeech;
    procedure SaveSpeechConfiguration;
    procedure SelectActiveControl;
    procedure SpButton3Click(Sender: TObject);
    function GetActiveSpeech:byte;
    procedure SpComboBox2Click(Sender: TObject);
    procedure SpCheckBox5Click(Sender: TObject);
    procedure SpButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpButton2Click(Sender: TObject);
    procedure SpButton4Click(Sender: TObject);
    procedure A_MessageExecute(Sender: TObject);
    procedure SendMessage( Nick, Text : string);
    procedure A_WhoExecute(Sender: TObject);
    procedure DoConnect;
    procedure DoDisconnect;
    procedure Connect;
    procedure Disconnect;
    procedure CreateLogFile;
    procedure AddToLog( data : string );
    procedure DestroyLogFile;
    procedure Button2Click(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
  private
  public
  end;

procedure Speak(s : string );

var
  Form1: TForm1;
  TraficF : TextFile;
  SpeechConfigRec : SpeechConfigurationRecord;
  LangID, OldLangID : dword;
//  ChannelTree : TTreeNode; // temp data

  cServerName,
  cPort,
  cUserName,
  cNick : string;

  ReciveCount,
  SendCount  : int64;
  ChannelFormFocuse : integer;

  StartTime, CurentTime, WorkTime : TDateTime;

implementation
{$R *.dfm}
uses Unit3, connect, Channel, Unit5, Status, About, Faworits, Master,
     Team;

procedure TForm1.IRCReceive(Sender: TObject; ACommand: String);
begin
 AddToLog('> ' + ACommand );
 if GlobalCodePageName = Koi8Name then Koi8toWin(PChar(ACommand),length(ACommand));
 inherited;
end;

procedure TForm1.IRCSend(Sender: TObject; ACommand: String);
begin
 AddToLog('< ' + ACommand );
 if GlobalCodePageName = Koi8Name then ACommand := Win_KoiConvert(ACommand);
 inherited;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 e : integer;
begin
 e := GetChannelForm('test');
 if e < 0 then Exit;
 ChannelForm[e].Recive( 'test ', 'esr '+#3+'14asdasd weqqe q wqe', 'no topic', nil);
end;

procedure TForm1.A_Panels4Click(Sender: TObject);
begin
// 
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
// IRC.Say(Edit1.Text,Edit2.Text);
end;

procedure TForm1.FormActivate(Sender: TObject);
var
 smode : string;
begin
 inherited;
 if RunOnce then
 begin
  RunOnce := False;

  StatusForm := TStatusForm.Create( Self );
  Speech1.Speak('         .');

  smode := cstr('smode');
  if smode='master' then MasterForm.Show
   else
    begin
     if smode='connect' then doconnect
      else Form2.Show;
    end;
 end;
end;

procedure TForm1.IRCList(Sender: TObject; AChans: TStringList; APosition: Integer; ALast: Boolean);
var
 i, j, e, f : integer;
 s, s1, s2 ,s3  : string;
 Strings : TStrings;
//  NewColumn: TListColumn;
  ListItem: TListItem;
begin
 Application.ProcessMessages;
// GetChannelList1Click(Sender);
 if Form3=nil then Form3.Create(Self);
 Form3.Panel2.Visible := true;
 Form3.ProgressBar1.Max := 2000;

 if APosition <= Form3.ProgressBar1.Max then Form3.ProgressBar1.position := APosition
  else
   begin
    Form3.ProgressBar1.Max := APosition + 400;
    Form3.ProgressBar1.Position := APosition;
   end;

 if Alast then Form3.ProgressBar1.Max := APosition;


 Form3.ListView2.Clear;

 for i:=0 to AChans.Count-1 do
  begin
   e := 0;
   s1 := '';
   s2 := '';
   s3 := '';

   for j:=1 to length(AChans[i]) do
    begin
     if e<1 then
       begin
       if AChans[i][j]<>' ' then s1 := s1 + AChans[i][j]
                            else e :=1;
       end
       else
        if e<2 then
        begin
           if AChans[i][j]<>' ' then s2 := s2 + AChans[i][j]
                                else e :=2;
        end
        else
         if e<3 then
         // if AChans[i][j] > chr(30) then s3 := s3 + AChans[i][j]
          s3 := s3 + AChans[i][j]
    end;

     ListItem := Form3.ListView2.Items.Add;
     ListItem.Caption := FilterMessage(s1 );
     ListItem.SubItems.Add(FilterMessage(s2 ));
     ListItem.SubItems.Add(FilterMessage(s3 ));

   end;

 Form3.AddFiltredChannel;

 if Alast then
  begin
   Form3.Panel2.Visible := false;
//
   Strings  := TStringList.Create;
   Strings.Add('   '+IRC.Host+' '+datetostr(now)+' '+timetostr(now)+'   '+inttostr(Form3.ListView2.Items.Count-1)+ ' ');

   for i:=0 to Form3.ListView2.Items.Count-1 do
    begin
     s := Form3.ListView2.Items[i].Caption;
     for j := 1 to length(s) do if s[j]=#0 then s[j] := ' ';
     Strings.Add(s);

     s := Form3.ListView2.Items[i].SubItems[0];
     for j := 1 to length(s) do if s[j]=#0 then s[j] := ' ';
     Strings.Add(s);

     s := Form3.ListView2.Items[i].SubItems[1];
     for j := 1 to length(s) do if s[j]=#0 then s[j] := ' ';
     Strings.Add(s);
    end;
   Strings.SaveToFile('1.lst');
  end;
//
end;



procedure TForm1.A_ChannelListExecute(Sender: TObject);
begin
 ChannelListForm.Show;
 ChannelListForm.SetFocus;

end;

procedure TForm1.DisConnect1Click(Sender: TObject);
begin
 IRC.Disconnect;
end;

procedure TForm1.IRCError(Sender: TObject; AUser: TIdIRCUser; ANumeric, AError: String);
begin
 if AUser=nil then Exit;

 AddStatus('ERROR '+ AUser.Nick + ' ' + AError,clRed);
 SetAllChannelEvent('ERROR '+ AUser.Nick + ' ' + AError);
end;

procedure TForm1.Jointochanel1Click(Sender: TObject);
begin
 IRC.Join('#Hatka','');
end;

procedure TForm1.IRCJoined(Sender: TObject; AChannel: TIdIRCChannel);
var
 e : integer;
begin
   AddStatus('JOINED '+  AChannel.Name,clGray);

  e := CreateChannelForm( AChannel );
  if e = -1 then Exit;
  ChannelForm[e].Joined( AChannel );


end;

procedure TForm1.A_Connect1Click(Sender: TObject);
begin
 if IRC.Connected then DoDisconnect
                  else DoConnect; 
end;

procedure TForm1.A_SetSpeakPanelClickClick(Sender: TObject);
begin
 Panel1.Visible := not( Panel1.Visible );
 ToolButton3.Down := Panel1.Visible ;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 if GetActiveSpeech = 1 then
  begin
   SpeechConfigRec.InterfaceEngineName := SpComboBox1.Text;
   Speech1.SelectEngine( SpComboBox1.Text );
  end;

 if GetActiveSpeech = 2 then
  begin
   SpeechConfigRec.ChannelEngineName := SpComboBox1.Text;
   Speech2.SelectEngine( SpComboBox1.Text );
  end;
 SaveSpeechConfiguration;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
 if GetActiveSpeech = 1 then
  begin
   SpeechConfigRec.IESpeed := ScrollBar1.Position ;
   Speech1.Speed :=  ScrollBar1.Position;
  end;

 if GetActiveSpeech = 2 then
  begin
   SpeechConfigRec.CESpeed := ScrollBar1.Position ;
   Speech2.Speed :=  ScrollBar1.Position;
  end;
 SaveSpeechConfiguration;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
 if GetActiveSpeech = 1 then
  begin
   SpeechConfigRec.IEPitch := ScrollBar2.Position ;
   Speech1.Pitch :=  ScrollBar2.Position;
  end;

 if GetActiveSpeech = 2 then
  begin
   SpeechConfigRec.CEPitch := ScrollBar2.Position ;
   Speech2.Pitch :=  ScrollBar2.Position;
  end;
 SaveSpeechConfiguration;  
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
 if GetActiveSpeech = 1 then
  begin
   SpeechConfigRec.IEVolume := ScrollBar3.Position ;
   Speech1.Volume :=  ScrollBar3.Position;
  end;

 if GetActiveSpeech = 2 then
  begin
   SpeechConfigRec.CEVolume := ScrollBar3.Position ;
   Speech2.Volume :=  ScrollBar3.Position;
  end;

 SaveSpeechConfiguration;
end;

procedure TForm1.IRCMessage(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel; Content: String);
var
 ChannelPointer : integer;
begin
  if AChannel = nil then
   begin
    ChannelPointer := GetChannelForm( AUser.Nick );
    if ChannelPointer < 0 then ChannelPointer  := CreateChannelForm( AUser );
    ChannelForm[ChannelPointer].PersonalRecive(  AUser.Nick, Content );
   end
  else
   begin
    ChannelPointer := GetChannelForm( AChannel.Name );
    if ChannelPointer < 0 then Exit;
    ChannelForm[ChannelPointer].Recive( AUser.Nick, Content, AChannel.Topic, AChannel.Names );
   end;
end;

procedure TForm1.A_KeyboardClick(Sender: TObject);
begin
 Channel.MyKeyboard := not ( Channel.MyKeyboard );
end;

procedure TForm1.A_Exit1Click(Sender: TObject);
begin
 Form1.Close;
end;

procedure Speak(s : string );
begin
 if GlobalCanSpeak then
  begin
   Form1.Speech2.Speak(Form1._Filter(s));
  end;
end;
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 GlobalCanSpeak := SpCheckBox1.Checked;
end;

procedure TForm1.IRCJoin(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel);
begin
  AddStatus('JOIN '+ AUser.Nick + ' ' + AChannel.Name,clGray);
  SetChannelEvent( AChannel.Name, AUser.Nick+ '   ' +  AChannel.Name );
  UpdateUserList( AChannel );
end;

procedure TForm1.IRCPart(Sender: TObject; AUser: TIdIRCUser;AChannel: TIdIRCChannel);
var
 e : word;
begin
   AddStatus('PART '+ AUser.Nick+' '+ AChannel.Name,clGray);
   SetChannelEvent(AChannel.Name,AUser.Nick+'  '+ AChannel.Name);
   e := GetChannelForm(AChannel.Name);
   if e < 0 then Exit;
   ChannelForm[e].DeleteFromUserList(AUser.Nick);
end;

                       
procedure TForm1.Create1Click(Sender: TObject);
begin
 Form5.ShowModal;
end;

procedure TForm1.IRCDCCChat(Sender: TObject; ANick, AIp, APort: String);
begin
   AddStatus('DCC  Chat '+ANick +' '+APort,clGray);
end;



procedure TForm1.IRCDCCAccept(Sender: TObject; ANick, APort, AFileName,
  APosition: String);
begin
  AddStatus('DCC Accept '+ANick +' '+APort +' '+AFileName +' '+APosition ,clGray);
end;

procedure TForm1.IRCDCCResume(Sender: TObject; ANick, APort, AFileName,APosition: String);
begin
   AddStatus('DCC Resume '+ANick +' '+APort +' '+AFileName +' '+APosition ,clGray);
end;

procedure TForm1.IRCDCCSend(Sender: TObject; ANick, AIp, APort, AFileName,
  AFileSize: String);
begin
   AddStatus('DCC Send '+ANick +' '+APort,clGray);
end;


procedure TForm1.IRCChannelMode(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; AChanName, AModes: String);
var
 e, j : integer;

begin
  AddStatus('MODE ' +  AChanName + '['+AModes+']',clGray);

///
 e := GetChannelForm( AChannel.Name );
 if e=-1 then exit;

 repeat
  application.ProcessMessages;
 until ChannelForm[e].SpListView1 <> nil;

 ChannelForm[e].Caption := AChannel.Name + '['+AChannel.ModeString+']';
 ChannelForm[e].UpdateUserList(AChannel.Names);



end;

procedure TForm1.IRCChannelModeChanged(Sender: TObject; AUser: TIdIRCUser;  AChannel: TIdIRCChannel);
var
 e : integer;
begin
  AddStatus('MODE CHANGED ' +  AChannel.Name + ' by '+ AUser.Nick,clGray);
  SetChannelEvent(AChannel.Name,'MODE CHANGED ' +  AChannel.Name + ' by '+ AUser.Nick);

  e := GetChannelForm( AChannel.Name );
  if e=-1 then exit;

  ChannelForm[e].Caption := AChannel.Name + '['+AChannel.ModeString+']';
  ChannelForm[e].UpdateUserList(AChannel.Names);

end;

procedure TForm1.IRCChannelUpdate(Sender: TObject;
  AUpdateType: TIdIRCChannelUpdateType; AUser: TIdIRCUser; AInfo: Integer);
begin
 if AUser=nil then Exit;
  AddStatus('UPDATE ' + ' by '+ AUser.Nick,clGray);

end;

procedure TForm1.IRCBan(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; AHostmask: String);
begin
  AddStatus('***BAN ' +  AChannel.Name + ' '+ AHostmask,clGray);
  SetChannelEvent( AChannel.Name,'BAN');
end;

procedure TForm1.IRCInvite(Sender: TObject; AUser: TIdIRCUser;
  AChannel: String);
begin
  AddStatus( AUser.Nick + ' ' + AChannel,clGray);
end;

procedure TForm1.IRCInviting(Sender: TObject; ANick, AChannel: String);
begin
  AddStatus('INVITING '+ ANick + ' ' + AChannel,clGray);
end;

procedure TForm1.IRCKick(Sender: TObject; AUser, AVictim: TIdIRCUser;
  AChannel: TIdIRCChannel);
begin
  AddStatus('KICK '+ AUser.Nick +' '+  AVictim.Nick + AChannel.Name  ,clGray);
  SetChannelEvent(AChannel.Name,'KICK '+ AUser.Nick +' '+  AVictim.Nick + AChannel.Name );
  UpdateUserList(AChannel);
  play('kick');
end;

procedure TForm1.IRCKicked(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel);
begin
  AddStatus('KICKED '+ AUser.Nick +' '+AChannel.Name  ,clGray);
  SetChannelEvent(AChannel.Name,'KICKED '+ AUser.Nick );
  UpdateUserList(AChannel);
  play('Kiked');
end;

procedure TForm1.IRCKill(Sender: TObject; User: TIdIRCUser; AVictim,
  AReason: String);
begin
   AddStatus('KILL '+ User.Nick +' '+  AVictim + ' ' + AReason  ,clGray);
   
end;

procedure TForm1.IRCLinks(Sender: TObject; AMask, AServer, AHopCount,
  AServerInfo: String);
begin
   AddStatus('LINKS '+AMask+' '+AServer+' '+AHopCount+' '+AServerInfo  ,clGray);
end;

procedure TForm1.IRCNames(Sender: TObject; AUsers: TIdIRCUsers;AChannel: TIdIRCChannel);
var
 e,i : word;
 s : TStrings;
begin
   AddStatus('NAMES '+AUsers.Items[0].Nick,clGray);
//   e := GetChannelForm(AChannel.Name);
//   if e = 0 then Exit;

{   s := TStrings.Create;
   for i:=1 to AUsers.Count-1 do
    begin
     s.Add(AUsers.Items[i].Nick );
    end;
   ChannelForm[e].UpdateUserList(s);
   s.Destroy;}
end;

procedure TForm1.IRCNickChange(Sender: TObject; AUser: TIdIRCUser;
  ANewNick: String);
begin
   AddStatus('NICK CHANGE '+ AUser.Nick + ' now is '+ ANewNick,clGray);

end;

procedure TForm1.IRCNickChanged(Sender: TObject; AOldNick: String);
begin
   AddStatus('NICK CHANGED '+ ' old nick '+ AOldNick,clGray);
end;

procedure TForm1.IRCNicksInUse(Sender: TObject; var ANick: String);
begin
   AddStatus('NICK IN USE '+  ANick,clGray);
end;

procedure TForm1.IRCNotice(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; Content: String);
begin
  if AChannel=nil then Exit;
  if AUser=nil then Exit;
   AddStatus('NOTICE '+  AUser.Nick+' '+AChannel.Name+Content ,clGray);
end;

procedure TForm1.IRCNoTopic(Sender: TObject; AChannel: TIdIRCChannel;
  AContent: String);
begin
   AddStatus('NO TOPIC '+ AChannel.Name +' '+AContent ,clGray);
end;

procedure TForm1.IRCNowAway(Sender: TObject; AContent: String);
begin
   AddStatus('NOW AWAY '+ AContent ,clGray);
end;

procedure TForm1.IRCOp(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; ATarget: TIdIRCUser);
begin
   if ATarget = nil then Exit;
    AddStatus('OP '+ AUser.Nick+' '+AChannel.Name+' target '+ ATarget.Nick,clGray);
end;

procedure TForm1.IRCParted(Sender: TObject; AChannel: TIdIRCChannel);
var
 e : integer;
begin
   AddStatus('PARTED '+ AChannel.Name,clGray);
   SetChannelEvent(AChannel.Name,'   '+ AChannel.Name);

   e := GetChannelForm(AChannel.Name);
   if e < 0 then Exit;
    ChannelForm[e].Close;

end;

procedure TForm1.IRCPingPong(Sender: TObject);
begin
   AddStatus('PING-PONG ',clGray);
   play('pingpong');
end;

procedure TForm1.IRCQuit(Sender: TObject; AUser: TIdIRCUser);
begin
   AddStatus('QUIT ',clGray);
end;

procedure TForm1.IRCRaw(Sender: TObject; AUser: TIdIRCUser; ACommand,
  AContent: String; var Suppress: Boolean);
begin
//   AddStatus('RAW '+AUser.Nick+' '+ACommand+' '+AContent,clGray);
end;

procedure TForm1.IRCSocketError(Sender: TObject; ASocket, AMsg: String);
begin
   AddStatus('Socket Error '+ASocket+' '+AMsg,clRed);
end;

procedure TForm1.IRCStateChange(Sender: TObject);
begin
   AddStatus('STATE CHANGE ',clGray);
end;

procedure TForm1.IRCSystem(Sender: TObject; AUser: TIdIRCUser;
  ACmdCode: Integer; ACommand, AContent: String);
begin
//AddStatus('SYSTEM '+AUser.Nick+' '+ACommand+' '+AContent,clGray);
 if ACommand = cmd_WELCOME  then
  begin
   AddStatus( AContent, clBlue);
 //  AddDayTeam( AContent, clBlue);
  end
 else
   if ACommand = cmd_LUSER then
    begin
     AddStatus( AContent, clGreen);
//     AddDayTeam( AContent, clGreen);
    end
    else
     if ACommand = cmd_MOTD  then
      begin
       AddStatus( AContent, clBlack);
       if ACmdCode = 372 then AddDayTeam( AContent , clBlack );
       if ACmdCode = 376 then irc.Join('#spirc');
      end
       else
        AddStatus('SYSTEM '+AUser.Nick+' '+ACommand+' '+AContent,clGray);
end;

procedure TForm1.IRCTopic(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; const AChanName, ATopic: String);
begin
   AddStatus('TOPIC '+AUser.Nick+' '+AChannel.Name+' '+ ATopic,clGray);
   SetChannelEvent(AChannel.Name,'TOPIC '+ AUser.Nick+' '+AChannel.Topic );
end;

procedure TForm1.IRCUnAway(Sender: TObject; AContent: String);
begin
   AddStatus('UNAWAY '+AContent,clGray);
end;

procedure TForm1.IRCUnban(Sender: TObject; AUser: TIdIRCUser;
  AChannel: TIdIRCChannel; AHostmask: String);
begin
   AddStatus('UNBAN '+AUser.Nick + ' ' + AChannel.Name + ' '+ AHostmask,clGray);
end;

procedure TForm1.IRCUnknownCommand(Sender: TObject; AUser: TIdIRCUser;
  ACommand, AContent: String);
begin
    AddStatus('Unknown Command '+AUser.Nick+' '+ACommand+' '+AContent,clGray);
end;

procedure TForm1.IRCUserMode(Sender: TObject; AModes: String);
begin
    AddStatus('USER MODE '+ AModes,clGray);
end;

procedure TForm1.IRCUserModeChanged(Sender: TObject);
begin
     AddStatus('USER MODE CHANGED ',clGray);
end;

procedure TForm1.IRCVoice(Sender: TObject; AUser: TIdIRCUser; AChannel: TIdIRCChannel; ATarget: TIdIRCUser);
begin
 if (AUser=nil) or (AChannel=nil) or (ATarget=nil) then Exit;
     AddStatus('VOICE '+AUser.Nick+' '+AChannel.Name+' '+ATarget.Nick,clGray);
end;

procedure TForm1.IRCWallops(Sender: TObject; AUser: TIdIRCUser;
  AContent: String);
begin
     AddStatus('WALLOPS '+AUser.Nick,clGray);
end;

procedure TForm1.IRCWork(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
     AddStatus('WORK ',clGray);
end;

procedure TForm1.IRCWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
     AddStatus('WORK BEGIN',clGray);
end;

procedure TForm1.IRCWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
     AddStatus('WORK END',clGray);
end;

procedure TForm1.A_CommandClick(Sender: TObject);
begin
//
end;

procedure TForm1.N1Click(Sender: TObject);
begin
 N1.Checked := Not(N1.Checked);
 ToolBar1.ShowCaptions := N1.Checked;
 if ToolBar1.ShowCaptions then
  begin
   ToolBar1.ButtonWidth  := 67;
   ToolBar1.ButtonHeight := 52;
   ToolBar1.Height := 60;
  end
 else
  begin
   ToolBar1.ButtonWidth  := 32;
   ToolBar1.ButtonHeight := 32;
   ToolBar1.Height := 48;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Speech2.Stop;

end;

procedure SaveConfig;
var
 F : textfile;
begin

  assignfile(f,StartDir +'/config.bin');
  rewrite(f);
  writeln(f,cServerName);
  writeln(f,cPort);
  writeln(f,cUserName);
  writeln(f,cNick);
  close(f);
end;




procedure TForm1.A_AboutExecute(Sender: TObject);
begin
 AboutForm.ShowModal;
end;

procedure TForm1.A_HelpExecute(Sender: TObject);
begin
 //
end;

procedure TForm1.SetChannelEvent( ChannelName, Event : string);
var
 e : integer;
begin
 e := GetChannelForm( ChannelName );
 if e = -1 then Exit;
 ChannelForm[e].ChannelEvent(Event);
end;

procedure TForm1.SetAllChannelEvent( Event : string);
var
 e : integer;
begin
 for e:=0 to ChannelFormSize do
   if ChannelForm[e]<>nil then  ChannelForm[e].ChannelEvent(Event);
end;


procedure TForm1.UpdateUserList( AChannel : TIdIRCChannel);
var
 e : integer;
begin
 e := GetChannelForm( AChannel.Name );
 if e = -1 then Exit;
  ChannelForm[e].UpdateUserList(AChannel.Names);
end;


procedure TForm1.A_PartExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('part ', '', s ) then
   IRC.Part(s,'see you letter');
end;

procedure TForm1.A_QueryExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('nick ?', '', s ) then
   CreateChannelForm( s );
end;


procedure TForm1.A_NoticeExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('nick and message ', '', s ) then
   IRC.Notice('',s);
end;
procedure TForm1.A_WhoisExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('whois ', '', s ) then
   IRC.Raw('WHOIS ' + s);
end;




procedure TForm1.A_BanExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('ban ', '', s ) then
   IRC.RAW('BAN '+s);

end;

procedure TForm1.A_KickExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('kick ', '', s ) then
   IRC.RAW('kick '+s);

end;

procedure TForm1.A_NickExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('nick ', '', s ) then
   IRC.Say('nick',s);
end;

procedure TForm1.A_WindowsExecute(Sender: TObject);
begin
//
end;

procedure TForm1.A_ToolsPanelExecute(Sender: TObject);
begin
 ToolBar1.Visible := not(ToolBar1.Visible);
end;

procedure TForm1.SpTreeView1CustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
//var
// e : integer;
begin
{  if node.Parent=nil then exit;
  e := GetChannelForm(Node.Text );
  if e < 0 then Exit;
  if ChannelFormFocuse = e then SpTreeView1.Canvas.Font.Color := clGreen;}

end;

procedure TForm1.IdConnectionIntercept1Receive(ASender: TIdConnectionIntercept; AStream: TStream);
begin
 ReciveCount := ReciveCount + (Astream.Size {div 1024 });
 Play('recive');
 StatusBar1.Panels[1].Text := inttostr(SendCount+ReciveCount);
end;

procedure TForm1.IdConnectionIntercept1Send(
  ASender: TIdConnectionIntercept; AStream: TStream);
begin
 SendCount := SendCount + (Astream.Size {div 1024 });
 Play('send');
 StatusBar1.Panels[1].Text := inttostr(SendCount+ReciveCount);
end;

procedure TForm1.A_CP1251Execute(Sender: TObject);
begin
 GlobalCodePageName := win1251name;
 StatusBar1.Panels[3].Text := GlobalCodePageName;
end;

procedure TForm1.A_KOI8Execute(Sender: TObject);
begin
 GlobalCodePageName := koi8name;
 StatusBar1.Panels[3].Text := GlobalCodePageName;
end;

procedure TForm1.A_OEMExecute(Sender: TObject);
begin
 GlobalCodePageName := oemname;
 StatusBar1.Panels[3].Text := GlobalCodePageName;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 StatusBar1.Panels[3].Text := GlobalCodePageName;

end;

procedure TForm1.A_CodePageExecute(Sender: TObject);
begin
///
end;

procedure TForm1.IdConnectionIntercept1Connect(
  ASender: TIdConnectionIntercept);
begin
 CreateLogFile;
 Connect;
end;

procedure TForm1.IdConnectionIntercept1Disconnect(ASender: TIdConnectionIntercept);
begin
 DestroyLogFile;
 Disconnect;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 GetDir(0,StartDir);
 StartTime := now;
 ConfigureSpeech;
 ConfigureComponentCaptionText;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
{ if statusfile = '3.bmp' then
  begin
   Exit;
   StartTime := now;
   WorkTime := 0;
  end;}
 CurentTime := now;
 WorkTime := StartTime - CurentTime;
 StatusBar1.Panels[2].Text := TimeToStr( WorkTime );

end;

procedure TForm1.ConfigureComponentCaptionText;
begin
 ToolButton1.Caption :=CStr( 'ToolButton1' );
 ToolButton2.Caption :=CStr( 'ToolButton2' );
 ToolButton3.Caption :=CStr( 'ToolButton3' );
 ToolButton4.Caption :=CStr( 'ToolButton4' );
 ToolButton5.Caption :=CStr( 'ToolButton5' );
 ToolButton6.Caption :=CStr( 'ToolButton6' );

 Label1.Caption := CStr('Label1');
 Label2.Caption := CStr('Label2');
 Label3.Caption := CStr('Label3');
 Label4.Caption := CStr('Label4');


 SpCheckBox1.Caption := CStr('CheckBox1');
// SpCheckBox2.Caption := CStr('CheckBox2');

 Button1.Caption := CStr('Button1');
 A_Server.Caption := CStr('Server');
 A_Tools.Caption := CStr('A_Tools');
 A_Who.Caption := CStr('A_Who');
 A_ConfigEditor.Caption := CStr('A_ConfigEditor');
 A_ChannelList.Caption := CStr('A_ChannelList');
 A_Message.Caption := CStr('A_Message');
 A_Connect.Caption := CStr('Connect');
 A_Exit.Caption := CStr('ExitApp');
 A_SetSpeakPanel.Caption := CStr('Speech');
 Channels.Caption := CStr('Channels');
 A_Panels.Caption := CStr('SetSpeech');
// A_SetChannel.Caption := CStr('SetChannel');
 A_Keyboard.Caption := CStr('Keyboard');
 sep1.Caption := CStr('sep1');
 A_Help.Caption := CStr('Help');
 A_About.Caption := CStr('About');
 A_Join.Caption := CStr('CJoin');
 A_Part.Caption := CStr('CPart');
 A_Query.Caption := CStr('CQueryUser');
 A_Notice.Caption := CStr('CSendNotice');
 A_Whois.Caption := CStr('CWhoisUser');
 A_Ban.Caption := CStr('CBan');
 A_Kick.Caption := CStr('CKick');
 A_Nick.Caption := CStr('CChangNick');
 A_Windows.Caption := CStr('Windows');
 A_SelectStatusPanel.Caption := CStr('SelectStatusPanel');
 A_ToolsPanel.Caption := CStr('SelectTools');
 A_SelectStatusPanel.Caption := CStr('SetControlPanel');
 A_CodePage.Caption := CStr('CodePage');
 A_CP1251.Caption := CStr('Win1251');
 A_Koi8.Caption := CStr('Koi8');
 A_OEM.Caption := CStr('OEM');

 Label6.Caption := CStr('SpCheckBox4');

 SpComboBox2.Items.Clear;
 SpComboBox2.Items.Add(CStr('SpComboBox2_int'));
 SpComboBox2.Items.Add(CStr('SpComboBox2_cn'));

 SpComboBox2.Text := CStr('SpComboBox2_int');
 SpButton1.Caption := CStr('SpButton1');
 SpButton2.Caption := CStr('SpButton2');
 SpButton3.Caption := CStr('SpButton3');
 SpButton4.Caption := CStr('SpButton4');
 SpButton5.Caption := CStr('SpButton5');

end;

procedure TForm1.A_GetFocuseExecute(Sender: TObject);
var
 hwnd : dword;
 p : pchar;
begin
  hwnd := GetParent(GetFocus);
  getmem(p,GetWindowTextLength(hwnd)+1);
  getwindowtext(hwnd,p,GetWindowTextLength(hwnd)+1);
  speech1.Speak(' ' + pchar(p));
  freemem(p);
end;


procedure TForm1.SayMainMenu( MenuPos , SubMenuPos : integer );
var
 s    : string;
 hkey : char;
begin
 Speech1.Stop;
 if MenuPos >= 0 then
  begin
   If SubMenuPos < 0 then
    begin
    s := MainMenu1.Items[MenuPos].caption;
//     if MFSayName then s := MainMenu1.Items[MenuPos].caption;
//     if MFSayHint then s := s + ', ' + MainMenu1.Items[MenuPos].hint;
//     if MFSayParent then s := ', ' + s;
//     CutHotKey( s , hkey );
//     if MFSayHotKey  then if hkey <> chr(0) then s := s + ' , , ' + hkey;
//     if MFSayEnabled then if MainMenu1.Items[MenuPos].Enabled = false then s := s + ' ';
     Speech1.Speak( s );

    end
   else
    begin
     s := MainMenu1.Items[MenuPos].Items[SubMenuPos].caption;
//     if MFSayHint then s := s + ', ' + MainMenu1.Items[MenuPos].Items[SubMenuPos].hint;
//     CutHotKey( s , hkey );
//     if MFSayHotKey  then if hkey <> chr(0) then s := s + ' , , ' + hkey;
//     if MFSayParent then s := MainMenu1.Items[MenuPos].caption + ', ' + s;
//     if MFSayIfDialog then if s[length(s)] = '.' then s := s + ' ,, ';
//     if MFSayShortCat then s := s + ShortCutToText( MainMenu1.Items[MenuPos].Items[SubMenuPos].shortcut);
//     if MFSayEnabled then if MainMenu1.Items[MenuPos].Items[SubMenuPos].Enabled = false then s := s + ' ';
     Speech1.Speak( s );

    end;
  end;
end;

procedure TForm1.MenuMessage(var Msg: TMessage);
var
 i , j , fmEdit , fsEdit, fmMain , fsMain : integer;
begin
 Speech1.Stop;

 FmEdit := -1;
 FsEdit := -1;
 FmMain := -1;
 FsMain := -1;

 if Msg.WParamHi = 144 then Speech1.Speak(MainMenu1.Items[Msg.WParamLo].Caption)
 else
  if ( Msg.WParamHi < 400 )
     or
     ( Msg.WParamHi = 896 )
        then
    begin // sub menu
       for i:=0 to MainMenu1.Items.Count-1 do
       for j:=0 to MainMenu1.Items[i].Count-1 do
       if Msg.WParamLo = GetMenuItemID( MainMenu1.Items[i].Handle,j) then
        begin
         FmMain := i;
         FsMain := j;
        end;
     SayMainMenu( FmMain , FsMain );
    end
    else  // systemmenu
     begin
      if Msg.WParamHi = 8336 then Speech1.Speak(' ');
      if Msg.WParamHi > 8300 then
       begin
        Case Msg.WParamLo of
         61728 : Speech1.speak('');
         61456 : Speech1.speak('');
         61440 : Speech1.speak('');
         61472 : Speech1.speak('');
         61488 : Speech1.speak('');
         61536 : Speech1.speak('');
        end;
       end;
      if Msg.WParamHi = 65535 then Speech1.Speak('  ');
     end;

 inherited;
end;

function TForm1._Filter(Text : string ):string;
var
 s : string;
 i : integer;
begin
 if text = '' then Exit;
 s := '';
 for i:=1 to length(text) do
  if text[i] >= #48 then s := s + text[i]
                    else s := s + ' ';
 _Filter := s;
end;


procedure TForm1.SpeakLang;
var
 CurrentLangName : string ;
begin
 LangID := GetKeyboardLayout(0);
 LangID := LangID and $00FF;
 if LangID <> OldLangID then
  begin
  case LangID of
   LangIDUkrainian : CurrentLangName := LangNameUkrainian;
   LangIDRussian   : CurrentLangName := LangNameRussian;
   LangIDEnglishUS : CurrentLangName := LangNameEnglishUS;
  else
   CurrentLangName := LangNameUnUse ;
  end;
   Speech2.Speak(CurrentLangName);
   OldLangID := LangID;
  end;
end;

procedure TForm1.FormHide(Sender: TObject);
begin
// ShowWindow(Application.Handle,sw_Hide);
end;

procedure TForm1.ToolBar2CustomDrawButton(Sender: TToolBar;
  Button: TToolButton; State: TCustomDrawState; var DefaultDraw: Boolean);
var
 e : integer;
begin
 e := GetChannelForm( Button.Caption  );
 if e > -1 then
  if ChannelForm[e].HaveMessage then ToolBar2.Canvas.Font.Color := clRed
                                else ToolBar2.Canvas.Font.Color := clBlack;

end;

//////

procedure TForm1.ChannelWathClick( Sender : TObject );
var
 e : integer;
begin
 e := GetChannelForm( TToolButton(Sender).Caption  );
 if e=-1 then exit;
 ChannelForm[e].Show;
 ChannelForm[e].SetFocus;
 ChannelForm[e].Refresh;
 ChannelForm[e].SpRichEdit1.SetFocus;
 TToolButton(Sender).Down := true;
end;

procedure TForm1.A_ServerExecute(Sender: TObject);
begin
///
end;

procedure TForm1.IRCStatus(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
begin
 StatusBar1.Panels[0].text := AStatusText;
end;

//////////////////////////////////////////////////////////////////
procedure TForm1.A_ToolsSetup(Sender: TObject);
begin
 Application.CreateForm(TForm2, Form2);
 Form2.Show;
 Form2.SetFocus;
end;

procedure TForm1.A_ConfigEditorExecute(Sender: TObject);
begin
 EditConfigForm.ShowModal;
end;

procedure TForm1.A_FaworitsExecute(Sender: TObject);
begin
 if FaworitsForm = nil then FaworitsForm.Create(self);
 FaworitsForm.Show;
end;

procedure TForm1.ConfigureSpeech;
var
 s : TStrings;
 i : integer;
begin
 with SpeechConfigRec do
  begin
    ActiveControl      := StrToInt(SpeechConfig('ActiveControl'));

    UseInterfaceEngine := StrToBool(SpeechConfig('UseInterfaceEngine'));
    UseChannelEngine   := StrToBool(SpeechConfig('UseChannelEngine'));

    InterfaceEngineName := SpeechConfig('InterfaceEngineName');
    IESpeed             := StrToInt(SpeechConfig('IESpeed'));
    IEPitch             := StrToInt(SpeechConfig('IEPitch'));
    IEVolume            := StrToInt(SpeechConfig('IEVolume'));
    IEUseMultiFilter    := StrToBool(SpeechConfig('IEUseMultiFilter'));
    IEUseSingleFilter   := StrToBool(SpeechConfig('IEUseSingleFilter'));

    ChannelEngineName   := SpeechConfig('ChannelEngineName');
    CESpeed             := StrToInt(SpeechConfig('CESpeed'));
    CEPitch             := StrToInt(SpeechConfig('CEPitch'));
    CEVolume            := StrToInt(SpeechConfig('CEVolume'));
    CEUseMultiFilter    := StrToBool(SpeechConfig('CEUseMultiFilter'));
    CEUseSingleFilter   := StrToBool(SpeechConfig('CEUseSingleFilter'));

     SpComboBox2.ItemIndex := ActiveControl;

     if SpComboBox1.Items.Count < 1 then
      begin
       s := Speech1.Engines;
       SpComboBox1.Items.Clear;
       for i:= 0 to s.count-1 do SpComboBox1.Items.Add(s[i]);
       //s.Destroy;
      end;


    if Speech1.Engines.Count > 0 then // if SAPI present but Engines does not exists
      begin
        if UseInterfaceEngine then
          begin
            if Speech1.Engines.IndexOf(InterfaceEngineName) >= 0
              then
                 Speech1.SelectEngine( InterfaceEngineName )
              else
                begin
                 Speech1.SelectEngine( Speech1.Engines[2] );
                 InterfaceEngineName := Speech1.Engines[2];
                end;
            Speech1.Speed := IESpeed;
            Speech1.Pitch := IEPitch;
            Speech1.Volume:= IEVolume;
          end;
        end;

       if Speech2.Engines.Count > 0 then // if SAPI present but Engines does not exists
        if UseChannelEngine then
         begin
            if Speech2.Engines.IndexOf(ChannelEngineName) >= 0
              then
                 Speech2.SelectEngine( ChannelEngineName )
              else
               begin
                 Speech2.SelectEngine( Speech2.Engines[0] );
                 ChannelEngineName := Speech2.Engines[0];
               end;
          Speech2.Speed := CESpeed;
          Speech2.Pitch := CEPitch;
          Speech2.Volume:= CEVolume;
         end;


    if IEUseMultiFilter then Speech1.LoadMultiRules('multirules.ini');
    if IEUseSingleFilter then Speech1.LoadSingleRules('singlerules.ini');

    if CEUseMultiFilter then Speech2.LoadMultiRules('multirules.ini');
    if CEUseSingleFilter then Speech2.LoadSingleRules('singlerules.ini');

    SelectActiveControl;

   end;
end;


procedure TForm1.SaveSpeechConfiguration;
begin
 with SpeechConfigRec do
  begin

    SaveSpeechConfig('UseInterfaceEngine', BoolToStr(UseInterfaceEngine));
    SaveSpeechConfig('UseChannelEngine', BoolToStr(UseChannelEngine));

    SaveSpeechConfig('InterfaceEngineName',InterfaceEngineName);
    SaveSpeechConfig('IESpeed', IntToStr(IESpeed));
    SaveSpeechConfig('IEPitch', IntToStr(IEPitch));
    SaveSpeechConfig('IEVolume', IntToStr(IEVolume));
    SaveSpeechConfig('IEUseMultiFilter', BoolToStr(IEUseMultiFilter));
    SaveSpeechConfig('IEUseSingleFilter', BoolToStr(IEUseSingleFilter));

    SaveSpeechConfig('ChannelEngineName',ChannelEngineName);
    SaveSpeechConfig('CESpeed', IntToStr(CESpeed));
    SaveSpeechConfig('CEPitch', IntToStr(CEPitch));
    SaveSpeechConfig('CEVolume', IntToStr(CEVolume));
    SaveSpeechConfig('CEUseMultiFilter', BoolToStr(CEUseMultiFilter));
    SaveSpeechConfig('CEUseSingleFilter', BoolToStr(CEUseSingleFilter));

    SaveSpeechConfig('ActiveControl',IntToStr(ActiveControl));

  end;
end;

procedure TForm1.SelectActiveControl;
begin
 with SpeechConfigRec do
 begin
 if ActiveControl=0 then
  begin
   SpCheckBox5.Checked := UseInterfaceEngine;
   if UseInterfaceEngine then
    begin
     SpComboBox1.Text := InterfaceEngineName;

     ScrollBar1.Max := Speech1.Info.MaxSpeed;
     ScrollBar1.Min := Speech1.Info.MinSpeed;
     ScrollBar1.Position := Speech1.Speed;

     ScrollBar2.Max := Speech1.Info.MaxPitch;
     ScrollBar2.Min := Speech1.Info.MinPitch;
     ScrollBar2.Position := Speech1.Pitch;

     ScrollBar3.Max := Speech1.Info.MaxVolume;
     ScrollBar3.Min := Speech1.Info.MinVolume;
     ScrollBar3.Position := Speech1.Volume;
    end;
   end
  else
   begin
   SpCheckBox5.Checked := UseChannelEngine;
   if UseChannelEngine then
    begin

     SpComboBox1.Text := ChannelEngineName;

     ScrollBar1.Max := Speech2.Info.MaxSpeed;
     ScrollBar1.Min := Speech2.Info.MinSpeed;
     ScrollBar1.Position := Speech2.Speed;

     ScrollBar2.Max := Speech2.Info.MaxPitch;
     ScrollBar2.Min := Speech2.Info.MinPitch;
     ScrollBar2.Position := Speech2.Pitch;

     ScrollBar3.Max := Speech2.Info.MaxVolume;
     ScrollBar3.Min := Speech2.Info.MinVolume;
     ScrollBar3.Position := Speech2.Volume;
   end;
   end;
  end;
end;


procedure TForm1.SpButton3Click(Sender: TObject);
begin
 if GetActiveSpeech=1 then
  begin
   Speech1.SelectEngine(SpComboBox1.Text);
   SelectActiveControl;
  end;

 if GetActiveSpeech=2 then
  begin
   Speech2.SelectEngine(SpComboBox1.Text);
   SelectActiveControl;
  end;
 SaveSpeechConfiguration;
end;

function TForm1.GetActiveSpeech:byte; {0-disable, 1-interface, 2-channel}
begin
 GetActiveSpeech := 0;
 with SpeechConfigRec do
  begin
   if (ActiveControl=0) and (UseInterfaceEngine) then GetActiveSpeech:= 1
    else
     if not(ActiveControl=1)and(UseChannelEngine) then GetActiveSpeech:= 2;
  end;
end;

procedure TForm1.SpComboBox2Click(Sender: TObject);
begin
 if SpComboBox2.Text = SpComboBox2.Items[0] then SpeechConfigRec.ActiveControl := 0
                                            else SpeechConfigRec.ActiveControl := 1;
 SelectActiveControl;
 SaveSpeechConfiguration;
end;

procedure TForm1.SpCheckBox5Click(Sender: TObject);
begin
 if GetActiveSpeech = 1 then
   SpeechConfigRec.UseInterfaceEngine := SpCheckBox5.Checked;

 if GetActiveSpeech = 2 then
   SpeechConfigRec.UseChannelEngine := SpCheckBox5.Checked;



 SaveSpeechConfiguration;
end;

procedure TForm1.SpButton1Click(Sender: TObject);
begin
 if GetActiveSpeech=1 then Speech1.Speak('    .')
                      else Speech2.Speak('    .');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SaveSpeechConfiguration;
 if IRC.Connected then DoDisconnect;
end;

procedure TForm1.SpButton2Click(Sender: TObject);
begin
 ShowPage := 5;
 EditConfigForm.ShowModal;
end;

procedure TForm1.SpButton4Click(Sender: TObject);
begin
 ShowPage := 4;
 EditConfigForm.ShowModal;
end;

procedure TForm1.A_MessageExecute(Sender: TObject);
begin
 SendMessage('','');
end;

procedure TForm1.SendMessage( Nick, Text : string);
var
 s1, s2 : string;
begin
 if Nick = '' then
  begin
   if InputQuery('Nick ?', '', s1 ) then
     if InputQuery('Message ?', '', s2 ) then IRC.Say( s1 , s2 );
  end
 else
  IRC.Say( Nick , Text );
end;

procedure TForm1.A_WhoExecute(Sender: TObject);
var
 s : string;
begin
 if InputQuery('who ', '', s ) then
   IRC.Raw('WHO ' + s);
end;

procedure TForm1.DoConnect;
begin
 if IRC.Connected then Exit
 else
  begin
   Refresh;
   IRC.Host := ConnectConfig('Server');
   IRC.Port := StrToInt(ConnectConfig('Port'));

   IRC.UserName := UserConfig('UserName');
   IRC.Replies.UserInfo := UserConfig('UserName');
   IRC.Nick := UserConfig('Nick');
   IRC.AltNick := UserConfig('AlterNick');

   if StrToBool(UserConfig('Invisible')) then IRC.UserMode := [umInvisible]
                                         else IRC.UserMode := [];

   try
    IRC.Connect;
   except
    _SpShowMessage('IRC',CStr('connection_faild')+' '+ IRC.Host);
   end;
  end;
end;

procedure TForm1.DoDisconnect;
begin
 IRC.Quit('');
 repeat
  Application.ProcessMessages  ;
 until not( IRC.Connected ); 
end;

procedure TForm1.Connect;
var
 e : integer;
begin
 play('connect');
 AddStatus(CStr('CONNECT') +  IRC.Host ,clGray);
 ToolButton1.Down := True;
 ToolButton1.ImageIndex := 7;

 ToolButton1.Hint := 'Disconnect with IRC Server';

 Form1.Caption := 'SpIRC ['+ IRC.Host + ':' + inttostr(IRC.Port)+']';

// FaworitsForm.Show;

// FaworitsForm.SetFocus;
end;

procedure TForm1.Disconnect;
begin
 Play('Disconnect');
 AddStatus('DISCONNECT '+ IRC.Host,clGray);
 SetAllChannelEvent('DISCONNECT '+ IRC.Host);
 ToolButton1.ImageIndex := 0;
 ToolButton1.Down := false;
 ToolButton1.Hint := 'Connect to IRC Server';

end;

procedure TForm1.CreateLogFile;
begin
{$I-}
 AssignFile( TraficF, StartDir +'\'+ LogFileName );
 if FileExists( StartDir +'\'+ LogFileName ) then Append( TraficF )
                                            else Rewrite( TraficF );
 Write( TraficF, '*** Connected to ' + IRC.Host + ' at ' + DateTimeToStr(Now)+#$0D+#$0A);
end;

procedure TForm1.AddToLog( data : string );
begin
{$I-}
 write( TraficF, Data +#$0D+#$0A );
end;

procedure TForm1.DestroyLogFile;
begin
{$I-}
 Write( TraficF, '*** Disconnected with ' + IRC.Host + ' at ' + DateTimeToStr(Now)+#$0D+#$0A);
 CloseFile( TraficF );
end;



procedure TForm1.Button2Click(Sender: TObject);
begin
 IRC.Raw('Users');
end;

procedure TForm1.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
 AddToLog('Exception: ' + E.Message);
end;

end.

