unit ChannelSetup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, SpCheckBox, SpButton, Config;

type
  TChannelSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpCheckBox1: TSpCheckBox;
    SpCheckBox2: TSpCheckBox;
    SpCheckBox3: TSpCheckBox;
    SpCheckBox4: TSpCheckBox;
    SpCheckBox5: TSpCheckBox;
    SpCheckBox6: TSpCheckBox;
    SpCheckBox7: TSpCheckBox;
    SpCheckBox8: TSpCheckBox;
    SpCheckBox9: TSpCheckBox;
    SpCheckBox10: TSpCheckBox;
    procedure SpButton2Click(Sender: TObject);
    procedure ConfigComponents;
    procedure FormActivate(Sender: TObject);
  private
  public
  end;

procedure  ShowChannelSetup(FormNumber : word);
var
  ChannelSetupForm: TChannelSetupForm;

implementation
{$R *.dfm}
Uses
 Main, Channel;

procedure  ShowChannelSetup(FormNumber : word);
begin
 if ChannelForm[FormNumber] = nil then Exit;
 with ChannelForm[FormNumber] do
  begin
   ChannelSetupForm.SpCheckBox1.Checked := SpeakOptions.CanSpeak;
   ChannelSetupForm.SpCheckBox2.Checked := SpeakOptions.SpeakNotFocused;
   ChannelSetupForm.SpCheckBox3.Checked := SpeakOptions.Signalonmessage;
   ChannelSetupForm.SpCheckBox4.Checked := SpeakOptions.SayNick;
   ChannelSetupForm.SpCheckBox5.Checked := SpeakOptions.SpeakOutgoingMessage;

   ChannelSetupForm.SpCheckBox6.Checked := ViewOptions.ShowTime;
   ChannelSetupForm.SpCheckBox7.Checked := ViewOptions.ShowNick;
   ChannelSetupForm.SpCheckBox8.Checked := ViewOptions.ShowMessages;
   ChannelSetupForm.SpCheckBox9.Checked := ViewOptions.ShowOutgoinMessage;
   ChannelSetupForm.SpCheckBox10.Checked:= ViewOptions.ShowServerMessages;

   ChannelSetupForm.ShowModal;

   if ChannelSetupForm.ModalResult = mrOk then
    begin
      SpeakOptions.CanSpeak := ChannelSetupForm.SpCheckBox1.Checked;
      SpeakOptions.SpeakNotFocused := ChannelSetupForm.SpCheckBox2.Checked;
      SpeakOptions.Signalonmessage := ChannelSetupForm.SpCheckBox3.Checked;
      SpeakOptions.SayNick := ChannelSetupForm.SpCheckBox4.Checked;
      SpeakOptions.SpeakOutgoingMessage := ChannelSetupForm.SpCheckBox5.Checked;

      ViewOptions.ShowTime := ChannelSetupForm.SpCheckBox6.Checked;
      ViewOptions.ShowNick := ChannelSetupForm.SpCheckBox7.Checked;
      ViewOptions.ShowMessages := ChannelSetupForm.SpCheckBox8.Checked;
      ViewOptions.ShowOutgoinMessage := ChannelSetupForm.SpCheckBox9.Checked;
      ViewOptions.ShowServerMessages := ChannelSetupForm.SpCheckBox10.Checked;
    end;
  end;
end;
procedure TChannelSetupForm.SpButton2Click(Sender: TObject);
begin
 Close;
end;

procedure TChannelSetupForm.ConfigComponents;
begin
  Caption := CStr('CSFCaption');

  GroupBox1.Caption := CStr('CSFGroupBox1');
  GroupBox2.Caption := CStr('CSFGroupBox2');

  SpButton1.Caption := CStr('CSFSpButton1');
  SpButton2.Caption := CStr('CSFSpButton2');

  SpCheckBox1.Caption := CStr('CSFSpCheckBox1');
  SpCheckBox2.Caption := CStr('CSFSpCheckBox2');
  SpCheckBox3.Caption := CStr('CSFSpCheckBox3');
  SpCheckBox4.Caption := CStr('CSFSpCheckBox4');
  SpCheckBox5.Caption := CStr('CSFSpCheckBox5');

  SpCheckBox6.Caption := CStr('CSFSpCheckBox6');
  SpCheckBox7.Caption := CStr('CSFSpCheckBox7');
  SpCheckBox8.Caption := CStr('CSFSpCheckBox8');
  SpCheckBox9.Caption := CStr('CSFSpCheckBox9');
  SpCheckBox10.Caption:= CStr('CSFSpCheckBox10');

end;

procedure TChannelSetupForm.FormActivate(Sender: TObject);
begin
 ConfigComponents;
end;

end.
