unit Status;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,Help, Service;

type
  TStatusForm = class(TForm)
    RichEdit1: TRichEdit;
    Panel1: TPanel;
    Edit1: TEdit;
    procedure RichEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Panel1Resize(Sender: TObject);
  private
  public
  end;

procedure AddStatus( Status : string; Color : int64);

var
  StatusForm: TStatusForm;

implementation

uses Main;
{$R *.dfm}

procedure AddStatus( Status : string; Color : int64 );
var
 F : TEXTFile;
begin
 if StatusForm = nil then Exit;
 if StatusForm.RichEdit1 = nil then Exit;
// if koi8 then  Status := Koi8toWin(PChar(Status),length(Status));

 StatusForm.RichEdit1.SelStart := length( StatusForm.RichEdit1.Text );
 StatusForm.RichEdit1.SelAttributes.Color := Color;
 StatusForm.RichEdit1.Lines.Add( Status );
 StatusForm.RichEdit1.SelStart := length( StatusForm.RichEdit1.Text );
// StatusForm.RichEdit1.SelAttributes.Color := clBlack;

 if fileexists('log.txt') then
  begin
   AssignFile(f,'log.txt');
   Append(f);
   write(f,status+#$0d+#$0a);
   closefile(f);
  end;
end;

procedure TStatusForm.RichEdit2KeyPress(Sender: TObject; var Key: Char);
begin
 if key = #$0D then
  begin
   Form1.IRC.Raw(Edit1.Text);
   Edit1.Clear;
  end;
 Inherited;
end;

procedure TStatusForm.FormResize(Sender: TObject);
begin
 Edit1.Width := Width;
end;

procedure TStatusForm.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = vk_f1 then GetHelp('Status');
end;

procedure TStatusForm.Panel1Resize(Sender: TObject);
begin
 edit1.Width := width;
end;

end.
