unit Routine;
interface

function ConfigureComponent( IniFileName, Section, Ident, Value: string ): string;
var
   StartDir : string;
implementation
uses IniFiles, SysUtils, Dialogs;
function ConfigureComponent( IniFileName, Section, Ident, Value: string ): string;
var
  Ini: TIniFile;
  GStr : string;
  F : TextFile;
begin
 if IniFileName = '' then Exit;
 if StartDir = '' then
  begin
   GetDir(0,StartDir);
   StartDir := StartDir + '\';
  end;

 if not(FileExists( StartDir + IniFileName )) then
  begin
  {$I+}
   AssignFile(F,StartDir + IniFileName);
   rewrite(F);
   if IOResult > 0 then Exit;
   write(F,' ; Speak Delphi Components inifile. AutoCreate at ' + DateTimeToStr(now));
   CloseFile(F);
  {$I-}
  end;

  Ini := TIniFile.Create( StartDir + IniFileName );
   try
    if FileExists( StartDir + IniFileName ) then GStr := Ini.ReadString( Section, Ident, '$NotExist' )
                                            else GStr := '$NotExist';
    if GStr = '$NotExist' then Ini.WriteString( Section, Ident, Value )
      else
         if GStr <> '' then Result := GStr;
   finally
    Ini.Free;
   end;
end;



end.
