unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus, Gauges, Buttons, Config,
  SpButton, SpComboBox,EditFaworit,SpShowMessage;

type
  TForm3 = class(TForm)
    PopupMenu1: TPopupMenu;
    SortChannelas1: TMenuItem;
    Data1: TMenuItem;
    Size1: TMenuItem;
    Panel2: TPanel;
    Label2: TLabel;
    ListView2: TListView;
    ListView1: TListView;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure SortChannelas1Click(Sender: TObject);
    procedure Data1Click(Sender: TObject);
    procedure Size1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure AddFiltredChannel;
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ConfigureComponents;
    procedure N1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
  private
  public
    ChannelListTreeNode : TTreeNode;
  end;

var
  Form3: TForm3;

implementation
{$R *.dfm}
uses
 Main, ChannelList;

procedure TForm3.Button1Click(Sender: TObject);
begin
// Form1.IRC.Join( SpComboBox1.Text,'' )
end;

procedure TForm3.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
//  If key = #$0D then  Form1.IRC.Join( SpComboBox1.Text,'' );
end;

procedure TForm3.ListView1Click(Sender: TObject);
begin
{ if ListView1.Selected <> nil then
  SpComboBox1.Text := ListView1.Selected.Caption;}
end;

procedure TForm3.ListView1DblClick(Sender: TObject);
begin
  if ListView1.Selected <> nil then
   Form1.IRC.Join( ListView1.Selected.Caption,'' )
   else _SpShowMessage(' ','      . ');
end;

procedure TForm3.SortChannelas1Click(Sender: TObject);
begin
 ListView1.SortType := stNone;
end;

procedure TForm3.Data1Click(Sender: TObject);
begin
  ListView1.SortType := stBoth;
end;

procedure TForm3.Size1Click(Sender: TObject);
var
 i,j : integer;
 s1,s2,s3 : string;
begin
 ListView1.SortType := stNone;
 ListView1.Items.BeginUpdate;
 for j:=0 to ListView1.Items.Count do
 begin
 for i:=0 to ListView1.Items.Count-2 do
  begin
   Application.ProcessMessages;
   if strtoint(ListView1.Items[i].SubItems[0])<strtoint(ListView1.Items[i+1].SubItems[0]) then
    begin
      s1 := ListView1.Items[i].Caption;
      s2 := ListView1.Items[i].SubItems[0];
      s3 := ListView1.Items[i].SubItems[1];

      ListView1.Items[i].Caption := ListView1.Items[i+1].Caption;
      ListView1.Items[i].SubItems[0] := ListView1.Items[i+1].SubItems[0];
      ListView1.Items[i].SubItems[1] := ListView1.Items[i+1].SubItems[1];

      ListView1.Items[i+1].Caption := s1;
      ListView1.Items[i+1].SubItems[0] := s2;
      ListView1.Items[i+1].SubItems[1] := s3;
    end;
  end;
 end;
 ListView1.Items.EndUpdate;
end;

procedure TForm3.FormActivate(Sender: TObject);


begin
 inherited;

 ConfigureComponents;

 Form1.Speech1.Speak( Caption );
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
 AddFiltredChannel;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
 Form1.IRC.Raw('LIST');
end;

procedure TForm3.AddFiltredChannel;
var
 i : integer;
begin
 ListView1.Items.BeginUpdate;
 ListView1.Items.Assign(ListView2.Items);

 i := 0;
 repeat
  if ListView1.Items[i]<>nil then
   begin
    if ListView1.Items[i].SubItems <> nil then
     if strtoint(ListView1.Items[i].SubItems[0])<ChannelListForm.UpDown3.Position then
      begin
       ListView1.Items[i].Delete;
       Dec(i);
      end;
   end;
  inc(i);
 until (i = ListView1.Items.Count)
       or
       (ListView1.Items.Count=0);

 ListView1.Columns[0].Caption := '  ' + inttostr(ListView1.Items.Count) + '  ' + inttostr(ListView2.Items.Count);

 ListView1.Items.EndUpdate;
end;


procedure TForm3.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
 if key = chr(VK_RETURN) then Button1Click(Sender);
end;

procedure TForm3.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var
 ItemRect: TRect;
 BkColor : dword;
begin
 if ChannelListForm.CheckBox1.Checked then
 begin
 if Item.SubItems    = nil then Exit;
 
 if Item.SubItems.Count = -1 then Exit;


    ItemRect :=  Item.DisplayRect(drBounds );
    ListView1.Canvas.Brush.Color := BkColor;
    ListView1.Canvas.FillRect(ItemRect)
  end
 else
  begin
    ListView1.Canvas.Font.Color := clBlack;
    BkColor := clWhite;
    ItemRect :=  Item.DisplayRect(drBounds );
    ListView1.Canvas.Brush.Color := BkColor;
    ListView1.Canvas.FillRect(ItemRect)
  end;


end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 ChannelListTreeNode.Destroy;
 Form3.Destroy;
end;

procedure TForm3.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
 ChannelListForm.SpComboBox1.Text := Item.Caption;
 Form1.Speech1.Stop;
 Form1.Speech1.Speak(Item.Caption + ' ' + Item.SubItems[0] + ' ' + Item.SubItems[1]);
end;

procedure TForm3.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=vk_return then N1Click(Sender);
end;

procedure TForm3.ConfigureComponents;
begin
 Caption := CStr('F3Caption');
 ListView1.Columns[0].Caption := CStr('F3ListViewColumns0');
 ListView1.Columns[1].Caption := CStr('F3ListViewColumns1');
 ListView1.Columns[2].Caption := CStr('F3ListViewColumns2');
end;


procedure TForm3.N1Click(Sender: TObject);
begin
 ChannelListForm.Show;
 ChannelListForm.SetFocus;
end;

procedure TForm3.N9Click(Sender: TObject);
begin
  Form1.IRC.Raw('LIST');
end;

procedure TForm3.N4Click(Sender: TObject);
begin
  with EditFaworitForm do
   begin
    SpEdit1.Text := ListView1.Selected.Caption;
    SpEdit3.Text := ListView1.Selected.SubItems[1];
    SpEdit4.Text := Form1.IRC.Host;    
   end;
  EditFaworitForm.Show;

end;

procedure TForm3.N2Click(Sender: TObject);
begin
  if ListView1.Selected <> nil then
   Form1.IRC.Join( ListView1.Selected.Caption,'' )
   else _SpShowMessage(' ','      . ');

end;

end.
