unit connect;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Main, jpeg, shellapi, Buttons, Help, Config,
  ComCtrls, ServerOptions,IdIRC,Service, SpEdit, SpCheckBox, SpComboBox,
  SpButton, SpRichEdit, SpShowMessage;

type

  TForm2 = class(TForm)
    Bevel1: TBevel;
    Label6: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    TabSheet3: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label1: TLabel;
    Label13: TLabel;
    SpEdit1: TSpEdit;
    SpEdit2: TSpEdit;
    SpEdit3: TSpEdit;
    SpEdit4: TSpEdit;
    SpCheckBox1: TSpCheckBox;
    SpComboBox1: TSpComboBox;
    SpComboBox2: TSpComboBox;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpButton3: TSpButton;
    SpButton4: TSpButton;
    SpButton5: TSpButton;
    SpButton6: TSpButton;
    SpRichEdit1: TSpRichEdit;
    SpButton7: TSpButton;
    SpButton8: TSpButton;
    Image1: TImage;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure LabeledEdit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BitBtn1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Form1HelpExecute(Sender: TObject);
    procedure Label2MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Label3MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ConfigureComponents;
    procedure Button3Click(Sender: TObject);
    procedure SaveConfig;
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ChengServerName;
    procedure TabSheet2Show(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure PageControl1Enter(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure TabSheet1Exit(Sender: TObject);
    procedure SpEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure SpButton8Click(Sender: TObject);
    procedure SpButton5Click(Sender: TObject);
  private
  public
  end;

var
  Form2: TForm2;
  ServerName : string;
implementation
{$R *.dfm}
Uses ServerList;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Form2.Visible := False;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
 inherited;
 SaveConfig;
 With Form1 do
  begin
   Refresh;
   IRC.Host := Form2.SpComboBox2.Text;
//   IRC.Port := StrToInt( Edit2.Text );
   IRC.Port := 6667;
   IRC.UserName := SpEdit1.Text;
   IRC.Replies.UserInfo := SpEdit2.Text;
   IRC.Nick := SpEdit3.Text;
   IRC.AltNick := SpEdit4.Text;
{   if SpCheckBox1.Checked then IRC.UserMode := [umInvisible]
                          else IRC.UserMode := [];}
   Form2.Visible := False;

   Form1.A_Connect1Click(Sender);
  end;
end;

procedure TForm2.Label2Click(Sender: TObject);
begin
 ShellExecute( 0 , nil , 'http://wtwsoft.narod.ru',nil,nil,SW_SHOWMAXIMIZED);
end;

procedure TForm2.Label3Click(Sender: TObject);
begin
  ShellExecute( 0 , nil , 'mailto:wtwsoft@narod.ru',nil,nil,SW_SHOWMAXIMIZED);
end;

procedure TForm2.Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
// Label1.Font.Color := clWhite;
end;

procedure TForm2.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
//  Label1.Font.Color := clSilver;
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Label3.Font.Color := clBlue;
 Label2.Font.Color := clBlue;
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
 SpComboBox2.Text := SpComboBox1.Text;
 ChengServerName;
 Form1.Speech1.Speak('  .');
 inherited;
 ConfigureComponents;
 SetFocus;
 Refresh;
end;

procedure TForm2.BitBtn2Click(Sender: TObject);
begin
 GetHelp('  ');
end;

procedure TForm2.LabeledEdit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_F1 then BitBtn2Click(Sender);
end;

procedure TForm2.BitBtn1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_F1 then BitBtn2Click(Sender);
end;

procedure TForm2.Button2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_F1 then BitBtn2Click(Sender);
end;

procedure TForm2.Form1HelpExecute(Sender: TObject);
begin
 //
end;

procedure TForm2.Label2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Label2.Font.Color := clRed;
 Label3.Font.Color := clBlue;
end;

procedure TForm2.Label3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Label3.Font.Color := clRed;
 Label2.Font.Color := clBlue;

end;

procedure TForm2.ConfigureComponents;
var
 i : integer;
begin
 Caption := CStr('F2Caption');

 Label5.Caption  := CStr('F2Label5');
  SpEdit1.SpeechName := Label5.Caption;
 Label8.Caption  := CStr('F2Label8');
  SpEdit2.SpeechName := Label8.Caption;
 Label9.Caption  := CStr('F2Label9');
  SpEdit3.SpeechName := Label9.Caption;
 Label10.Caption := CStr('F2Label10');
  SpEdit4.SpeechName := Label10.Caption;
 Label11.Caption := CStr('F2Label11');
  SpComboBox2.SpeechName := CStr('F2Label11');
  SpComboBox1.SpeechName := CStr('F2Label11');
 Label12.Caption := CStr('F2Label12');


 SpCheckBox1.Caption := CStr('F2CheckBox1');

 SpButton7.Caption := CStr('F2BitBtn2');
 SpButton1.Caption := CStr('F2Button1');
 SpButton2.Caption := CStr('F2Button2');
 SpButton3.Caption := CStr('F2Button3');
 SpButton4.Caption := CStr('F2Button4');
 SpButton5.Caption := CStr('F2Button5');
 SpButton6.Caption := CStr('F2Button6');
 SpButton8.Caption := CStr('F2Button8'); 

 TabSheet1.Caption := CStr('F2TabCaption1');
 TabSheet2.Caption := CStr('F2TabCaption2');
 TabSheet3.Caption := CStr('F2TabCaption3');
// Config
 SpEdit1.Text := UserConfig('UserName');
 SpEdit2.Text := UserConfig('EMail');
 SpEdit3.Text := UserConfig('Nick');
 SpEdit4.Text := UserConfig('AlterNick');
// SpCheckBox1.Checked := StrToBool(Conf('Invisible'));
 SpComboBox2.Text := UserConfig('IRCServer');
 ServerName :=  SpComboBox2.Text;

 LoadServersConfig;

 ChengServerName;

end;


procedure TForm2.Button3Click(Sender: TObject);
begin
 ServerOptions.AddServerDialog;
end;

procedure TForm2.SaveConfig;
begin
 SaveUserConfig('UserName',SpEdit1.Text);
 SaveUserConfig('EMail',SpEdit2.Text);
 SaveUserConfig('Nick',SpEdit3.Text);
 SaveUserConfig('AlterNick',SpEdit4.Text);

 SaveUserConfig('Invisible',BoolToStr(SpCheckBox1.Checked));
 SaveUserConfig('IRCServer',SpComboBox2.Text);
end;


procedure TForm2.Button4Click(Sender: TObject);
begin
 ServerOptions.ChengServerDialog( SpComboBox1.Text );
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
 inherited;
 ServerName := SpComboBox1.Text;
 ChengServerName;
end;

procedure TForm2.ChengServerName;
var
 i : integer;
begin
  SpComboBox2.Items.Clear;
  SpComboBox1.Items.Clear;

  SpComboBox1.Text := ConnectConfig('Server');
  SpComboBox2.Text := ConnectConfig('Server');  

  if ServersCount > 0 then
    for i:=1 to GetServersCount do SpComboBox1.Items.add( GetServerName(i) );

  SpComboBox2.Items.Assign(SpComboBox1.Items);

end;

procedure TForm2.TabSheet2Show(Sender: TObject);
begin
 SpComboBox1.Text := SpComboBox2.Text;
 ChengServerName;
end;

procedure TForm2.ComboBox2Change(Sender: TObject);
begin
 inherited;
 if GetServerNumber(SpComboBox1.Text) <> 0 then
  begin
    Label13.Caption := IRCServers[GetServerNumber(SpComboBox1.Text)].Description;
  end;


 ServerName := SpComboBox2.Text;
end;

procedure TForm2.PageControl1Enter(Sender: TObject);
begin
 Form1.Speech1.Speak(' ,  ' + PageControl1.ActivePage.Caption );
end;

procedure TForm2.PageControl1Change(Sender: TObject);
begin
 Form1.Speech1.Speak(' ' + PageControl1.ActivePage.Caption );
end;

procedure TForm2.TabSheet1Exit(Sender: TObject);
begin
 Form1.Speech1.Speak(' ,  ' + PageControl1.ActivePage.Caption );
end;


procedure TForm2.SpEdit1KeyPress(Sender: TObject; var Key: Char);
begin
inherited;
Form1.SpeakLang;

 if Key = chr(VK_RETURN) then Button1Click(Sender);
 if Key = chr(VK_ESCAPE) then Button2Click(Sender);

end;

procedure TForm2.SpButton8Click(Sender: TObject);
begin
 ServerListForm.ShowModal;
end;

procedure TForm2.SpButton5Click(Sender: TObject);
begin
 if ServerOptions.DeleteServer( SpComboBox1.Text ) = 0 then
  _SpShowMessage('Server list','no more exist servers in list.');
end;

end.
